terraform {
  required_version = ">= 0.12.26"

  required_providers {
    vault = {
      source  = "hashicorp/vault"
      version = "3.8.0"
    }
  }
}

provider "vault" {
  address = "https://vault:9123"
  # VAULT_TOKEN envvar should exist and be used
}

data "external" "get_envvars" {
  program = [
    "bash",
    "get_envvars.sh"
  ]
}

output "VAULT_TOKEN" {
  value = data.external.get_envvars.result.vault_token
}

resource "vault_kv_secret_v2" "main" {
  mount               = "pathtosecret"
  name                = "xxxxx"
  cas                 = 1
  delete_all_versions = true
  data_json = jsonencode(
    {
      add_more_secrets_manually = "change that value"
      or_rename_me              = "change that value"
    }
  )
}
